/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPORESU                                                 */
/* Tabela : TIPORESU                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 18/02/2003 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPORESU
BEFORE INSERT OR UPDATE OR DELETE
ON TIPORESU FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPRE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPORESU,0) <> NVL(:NEW.CDTIPORESU,0)) OR
         (NVL(:OLD.NMTIPORESU,0) <> NVL(:NEW.NMTIPORESU,0)) THEN
         :NEW.DTULTATUTPRE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPORESU', '', 'CDTIPORESU='||:OLD.CDTIPORESU||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPORESU MODIFY DTULTATUTPRE DEFAULT SYSDATE
/
