CREATE OR REPLACE TRIGGER LOG_SUP_FERIFILI
AFTER DELETE OR INSERT OR UPDATE
ON FERIFILI FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      V_DESC         := 'Filial = ' || ' ' || :NEW.CDFILIAL || ' ' ||
                        'Data do feriado = ' || ' ' || :NEW.DTFERIFILI || ' ' ||
                        'Feriado = ' || ' ' || :NEW.DSFERIFILI || ' ' ||
                        'Data da ltima atualizao = ' || :NEW.DTULTATUFEFI;

      V_ITPESQ       := :NEW.CDFILIAL || :NEW.DTFERIFILI;

      V_CDFILLOGOPER := :NEW.CDFILIAL;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC      := 'Filial = ' || ' ' || :NEW.CDFILIAL || ' ' ||
                        'Data do feriado = ' || ' ' || :NEW.DTFERIFILI || ' ' ||
                        'Feriado = ' || ' ' || :NEW.DSFERIFILI || ' ' ||
                        'Data da ltima atualizao = ' || :NEW.DTULTATUFEFI;

         V_ITPESQ     := :NEW.CDFILIAL || :NEW.DTFERIFILI;

         V_CDFILLOGOPER := :NEW.CDFILIAL;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   := 'Filial = ' || ' ' || :OLD.CDFILIAL || ' ' ||
                        'Data do feriado = ' || ' ' || :OLD.DTFERIFILI || ' ' ||
                        'Feriado = ' || ' ' || :OLD.DSFERIFILI || ' ' ||
                        'Data da ltima atualizao = ' || :OLD.DTULTATUFEFI;

            V_ITPESQ := :OLD.CDFILIAL || :OLD.DTFERIFILI;

            V_CDFILLOGOPER := :OLD.CDFILIAL;
            V_IDTIPOOPER   := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER,
       CDFILLOGOPER)
   VALUES
      ('FERIFILI',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       V_CDFILLOGOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_SUP_FERIFILI','5.30.000'); END;
/