/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

   TROCA_PRATO_CARD

   Procedure para substituir pratos no cardpio
   Criao: Dmaso (13/12/05)

   @C:\WEB_411\SQL\END_CONV\ORACLE\7820_PLASTPO_TROCA_PRATO_CARD.SQL
   EXECUTE TROCA_PRATO_CARD('0200','0000000001','31/10/2005','020103493','P','020104010','P');
*/
create or replace
PROCEDURE TROCA_PRATO_CARD
(
   P_LISTAFILI    IN VARCHAR2,
   P_LISTASERV    IN VARCHAR2,
   P_DTINICIAL    IN DATE,
   P_DTFINAL      IN DATE,
   P_CDPRATORIG   IN VARCHAR2,
   P_CDFAPRATORIG IN VARCHAR2,
   P_CDPRATDEST   IN VARCHAR2,
   P_CDFAPRATDEST IN VARCHAR2,
   P_MODOPROC     IN VARCHAR2,
   P_CDNVPRODUTO  IN VARCHAR2,
   P_CDOPERADOR   IN VARCHAR2,
   P_NRLOGINTCARD OUT VARCHAR2
) IS
   V_IDUTRPADCA   VARCHAR2(1);
   V_TIPORECE     VARCHAR2(1);
   V_IDCARDIAUTIL VARCHAR2(1);
   V_TIPOCARDAPIO VARCHAR2(1);
   V_NRLOGINTCARD VARCHAR2(20);
   V_QTDIABLOQCAR NUMBER(2);
   V_DTPROC       DATE;
   V_DTUTIL       DATE;
   V_BODIAUTIL    BOOLEAN;
   V_CONTINUE     BOOLEAN;
   V_DTLIBECARDMATR DATE;
   V_DTAPROCARDFILI DATE;
   V_DTAPROCARDMATR DATE;
   V_DTLIMAPROVFILI DATE;
   V_PRODINATIVO  VARCHAR2(1) := '0';
   V_EXISTE_PRATO VARCHAR2(1);
   V_OPERDOGRUPO VARCHAR2(12);
   V_IDLIBMATRIZ VARCHAR2(1); 
   V_CDPRATOMAT VARCHAR2(10);
   V_CDFILAUXPRATMAT VARCHAR2(4);   
   V_IDPRATOESPE VARCHAR2(1);
   V_IDCARDIAESPE VARCHAR2(1);
   V_IDMANCORCARDALT VARCHAR2(1);
   
BEGIN
   /* Verifica parametro Utiliza Receita Padrao no cardapio */   
   SELECT NVL(IDUTRPADCA, 'N'), NVL(QTDIABLOQCAR, 0), NVL(IDUTCARDPADR, 'N'), IDMANCORCARDALT
   INTO   V_IDUTRPADCA, V_QTDIABLOQCAR, V_TIPOCARDAPIO, V_IDMANCORCARDALT
   FROM   PARAMGERAL
   WHERE  CDPARGERAL = '0001';

   V_NRLOGINTCARD := NULL;
   V_CONTINUE     := FALSE;
   /* Corre os cardapios selecionados */
   FOR C_CARDAPIOS IN (
      SELECT C.CDFILIAL, C.CDSERVFILI, NVL(S.IDCARDDESCENTR, 'N') AS IDCARDDESCENTR, C.DTCARDAPIO,
             C.NRCARDAPIO, NVL(C.IDCARDIAESPE, 'N') AS IDCARDIAESPE, NVL(C.QTCOMESTICAR, 0) QTCOMESTICAR,
             C.DTMESCARD
      FROM   CARDADIA C, CARDAMES CM, LISTA LF, SERVICO S, (SELECT SUBSTR(CDLISTA, 1, 4) AS  CDFILIAL, 
                                                                   SUBSTR(CDLISTA, 5, 5) AS CDSERVIFILI 
                                                              FROM        LISTA
                                                           WHERE NRLISTA = P_LISTASERV)LS
      WHERE  LF.NRLISTA   = P_LISTAFILI         AND
             C.CDFILIAL   = LF.CDLISTA          AND
             C.CDSERVFILI = LS.CDSERVIFILI      AND
             C.DTCARDAPIO BETWEEN P_DTINICIAL AND P_DTFINAL AND
             C.CDFILIAL   = S.CDFILIAL          AND
             C.CDSERVFILI = S.CDSERVFILI        AND
             C.CDFILIAL   = CM.CDFILIAL(+)      AND
             C.CDSERVFILI = CM.CDSERVFILI(+)    AND
             C.DTMESCARD  = CM.DTMESCARDAPIO(+)
      ORDER BY C.CDFILIAL, C.CDSERVFILI, C.DTCARDAPIO)
   LOOP
         IF (V_TIPOCARDAPIO = 'D') AND (C_CARDAPIOS.IDCARDDESCENTR = 'S') AND (P_MODOPROC = 'F') THEN
            /*Verifica se o servio j est LIBERADO pela matriz, APROVADO pela filial, 
              APROVADO pela matriz ou se a data de LIMITE de aprovao pela filial expirou*/
            V_CONTINUE := FALSE;  /*Recebe false para limpar o valor quando for exportar para 2 meses*/
            BEGIN
               SELECT CTRL.DTLIBECARDMATR, CTRL.DTAPROCARDFILI, CTRL.DTAPROCARDMATR,
                      CALE.DTLIMAPROVFILI + NVL(QTDIAPRORAPROV , 0) AS DTLIMAPROVFILI
               INTO   V_DTLIBECARDMATR, V_DTAPROCARDFILI, V_DTAPROCARDMATR, V_DTLIMAPROVFILI
               FROM   CTRLAPROVCARD CTRL, CALENCARD CALE
               WHERE  CTRL.CDFILIAL       = C_CARDAPIOS.CDFILIAL   AND
                      CTRL.CDSERVFILI     = C_CARDAPIOS.CDSERVFILI AND
                      CTRL.DTMESCARDAPROV = C_CARDAPIOS.DTMESCARD  AND
                      CTRL.CDFILIAL       = CALE.CDFILIAL AND
                      CTRL.DTMESCARDAPROV = CALE.DTMESCALENCARD;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_DTLIBECARDMATR := NULL;
                  V_DTAPROCARDFILI := NULL;
                  V_DTAPROCARDMATR := NULL;
                  V_DTLIMAPROVFILI := NULL;
            END;
            /*Cardpio NO liberado pela MATRIZ*/
            IF V_DTLIBECARDMATR IS NULL THEN
               V_CONTINUE := TRUE;
            END IF;
            /*Cardpio J aprovado pela FILIAL*/
            IF NOT V_DTAPROCARDFILI IS NULL THEN            
               V_CONTINUE := TRUE;
            END IF;
            /*Cardpio J aprovado pela MATRIZ*/
            IF NOT V_DTAPROCARDMATR IS NULL THEN          
               V_CONTINUE := TRUE;
            END IF;
            /*Data limite de aprovao pela FILIAL expirada*/
            IF TRUNC(SYSDATE) > TRUNC(V_DTLIMAPROVFILI) THEN                                          
               V_CONTINUE := TRUE;
            END IF;            
         ELSE
            V_CONTINUE := FALSE;
         END IF;         
         
         IF NOT V_CONTINUE THEN
            SELECT MAX(DECODE(PG.IDUTILDTPROC, 'S', PF.DTPROCESSA, TRUNC(SYSDATE))) 
            INTO   V_DTPROC
            FROM   PARAMFILIAL PF, PARAMGERAL PG
            WHERE  PF.CDFILIAL = C_CARDAPIOS.CDFILIAL AND
                   PG.CDPARGERAL = '0001';
       
            IF (V_DTPROC IS NULL) THEN
               V_DTPROC := TRUNC(SYSDATE); 
            END IF;

            IF (C_CARDAPIOS.DTCARDAPIO >= (V_DTPROC + V_QTDIABLOQCAR)) THEN
               SELECT MAX(NVL(IDCARDIAUTIL, 'N'))
               INTO   V_IDCARDIAUTIL
               FROM   PARAMPLANEJA
               WHERE  CDFILIAL = C_CARDAPIOS.CDFILIAL;

               V_BODIAUTIL := TRUE;
               IF (V_IDCARDIAUTIL = 'S') THEN
                  SELECT MAX(DTFERIFILI)
                  INTO   V_DTUTIL
                  FROM   FERIFILI
                  WHERE  CDFILIAL   = C_CARDAPIOS.CDFILIAL AND
                         DTFERIFILI = C_CARDAPIOS.DTCARDAPIO;

                  IF (V_DTUTIL IS NOT NULL) THEN
                     V_BODIAUTIL := FALSE;
                  END IF;
               END IF;

               IF (V_BODIAUTIL) THEN
                  IF (C_CARDAPIOS.QTCOMESTICAR = 0) THEN
                  /* 1- Comensais do dia zerados */
                     IF V_NRLOGINTCARD IS NULL THEN
                        NOVO_CODIGO('LOGINTCARD'||C_CARDAPIOS.CDFILIAL, V_NRLOGINTCARD, 1);
                        V_NRLOGINTCARD := SUBSTR(V_NRLOGINTCARD,11,10);
                     END IF;
                     GRAVA_LOGINTCARD(V_NRLOGINTCARD, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDSERVFILI, C_CARDAPIOS.DTCARDAPIO, ' ', ' ', ' ',  '1');
                  ELSE

                  /* Verificar a receita utilizada pelo prato destino */
                     V_TIPORECE := 'N';
                     SELECT NVL(MAX(TIPO), 'N')
                     INTO   V_TIPORECE
                     FROM  (SELECT 'S' AS TIPO
                            FROM   RECESERV
                            WHERE  (CDFILIAL     = C_CARDAPIOS.CDFILIAL)   AND
                                   (CDSERVFILI   = C_CARDAPIOS.CDSERVFILI) AND
                                   (CDPRATO      = P_CDPRATDEST)           AND
                                   (CDFILAUXPRAT = P_CDFAPRATDEST)
                            UNION ALL
                            SELECT 'F' AS TIPO
                            FROM   RECEFILI F
                            WHERE  (CDFILIAL     = C_CARDAPIOS.CDFILIAL) AND
                                   (CDPRATO      = P_CDPRATDEST)         AND
                                   (CDFILAUXPRAT = P_CDFAPRATDEST)       AND
                                   NOT EXISTS (SELECT CDPRATO
                                               FROM   RECESERV
                                               WHERE  (CDFILIAL     = C_CARDAPIOS.CDFILIAL)   AND
                                                      (CDSERVFILI   = C_CARDAPIOS.CDSERVFILI) AND
                                                      (CDPRATO      = P_CDPRATDEST)           AND
                                                      (CDFILAUXPRAT = P_CDFAPRATDEST))
                            UNION ALL
                            SELECT 'P' AS TIPO
                            FROM   RECEPADR P
                            WHERE  (CDPRATO      = P_CDPRATDEST)   AND
                                   (CDFILAUXPRAT = P_CDFAPRATDEST) AND
                                   NOT EXISTS (SELECT CDPRATO
                                               FROM   RECEFILI
                                               WHERE  (CDFILIAL     = C_CARDAPIOS.CDFILIAL) AND
                                                      (CDPRATO      = P_CDPRATDEST)         AND
                                                      (CDFILAUXPRAT = P_CDFAPRATDEST))      AND
                                   NOT EXISTS (SELECT CDPRATO
                                               FROM   RECESERV
                                               WHERE  (CDFILIAL     = C_CARDAPIOS.CDFILIAL)   AND
                                                      (CDSERVFILI   = C_CARDAPIOS.CDSERVFILI) AND
                                                      (CDPRATO      = P_CDPRATDEST)           AND
                                                       (CDFILAUXPRAT = P_CDFAPRATDEST))) A;


                     IF (V_TIPORECE = 'N') THEN
                     /* 2- Prato sem receita */
                        IF V_NRLOGINTCARD IS NULL THEN
                           NOVO_CODIGO('LOGINTCARD'||C_CARDAPIOS.CDFILIAL, V_NRLOGINTCARD, 1);
                           V_NRLOGINTCARD := SUBSTR(V_NRLOGINTCARD,11,10);
                        END IF;
                        GRAVA_LOGINTCARD(V_NRLOGINTCARD, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDSERVFILI, C_CARDAPIOS.DTCARDAPIO, P_CDPRATDEST, ' ', P_CDFAPRATDEST,  '2');
                     ELSE
                        /*VERIFICAR SE EXISTE O PRATO NO CARDAPIO DESTINO*/
                        BEGIN
                          SELECT EXISTE
                          INTO V_EXISTE_PRATO
                          FROM ( SELECT 'S' EXISTE
                                 FROM COMPCARD
                                 WHERE  CDFILIAL     = C_CARDAPIOS.CDFILIAL AND
                                        NRCARDAPIO   = C_CARDAPIOS.NRCARDAPIO AND
                                        CDPRATO      = P_CDPRATORIG AND
                                        CDFILAUXPRAT = P_CDFAPRATORIG)
                          GROUP BY EXISTE;
                        EXCEPTION
                          WHEN NO_DATA_FOUND THEN
                               V_EXISTE_PRATO := NULL;
                        END;

                        V_PRODINATIVO := '0';
                        IF (V_EXISTE_PRATO ='S') THEN /*SE EXISTIR O PRATO NO CARDAPIO DESTINO*/
                             IF (V_TIPORECE = 'S') THEN  /*RECEITA POR SERVIO COM PRODUTO INATIVO*/

                                FOR C_RECESERV IN (
                                   SELECT  P.CDARVPROD, P.IDPRODATIVPR, NVL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                                   FROM   PRODUTO P, PRODFILI PF, RECESERV RS
                                   WHERE  PF.CDPRODUTO(+) = P.CDPRODUTO            AND
                                          PF.CDFILIAL (+) = C_CARDAPIOS.CDFILIAL   AND
                                          P.CDNVPRODUTO   = P_CDNVPRODUTO          AND
                                          RS.CDFILIAL     = C_CARDAPIOS.CDFILIAL   AND
                                          RS.CDSERVFILI   = C_CARDAPIOS.CDSERVFILI AND
                                          RS.CDPRATO      = P_CDPRATDEST           AND
                                          RS.CDFILAUXPRAT = P_CDFAPRATDEST         AND
                                          P.CDPRODUTO     = RS.CDPRODUTO)
                                LOOP
                                  IF (C_RECESERV.IDPRODATIV = 'I') OR (C_RECESERV.IDPRODATIVPR = 'N') THEN     /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                                     IF V_NRLOGINTCARD IS NULL THEN
                                        NOVO_CODIGO('LOGINTCARD'||C_CARDAPIOS.CDFILIAL, V_NRLOGINTCARD, 1);
                                        V_NRLOGINTCARD := SUBSTR(V_NRLOGINTCARD,11,10);
                                     END IF;
                                     V_PRODINATIVO := '1';
                                     GRAVA_LOGINTCARD(V_NRLOGINTCARD, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDSERVFILI, C_CARDAPIOS.DTCARDAPIO, C_RECESERV.CDARVPROD, ' ', P_CDFAPRATDEST,  '0');
                                  END IF;
                                END LOOP;

                             ELSE
                               IF (V_TIPORECE = 'F') THEN  /*RECEITA LOCAL COM PRODUTO INATIVO*/

                                  FOR C_RECEFILI IN (
                                      SELECT P.CDARVPROD, P.IDPRODATIVPR, NVL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                                      FROM   PRODUTO P, PRODFILI PF, RECEFILI RF
                                      WHERE  PF.CDPRODUTO(+) = P.CDPRODUTO          AND
                                             PF.CDFILIAL (+) = C_CARDAPIOS.CDFILIAL AND
                                             P.CDNVPRODUTO   = P_CDNVPRODUTO        AND
                                             RF.CDFILIAL     = C_CARDAPIOS.CDFILIAL AND
                                             RF.CDPRATO      = P_CDPRATDEST         AND
                                             RF.CDFILAUXPRAT = P_CDFAPRATDEST       AND
                                             P.CDPRODUTO     = RF.CDPRODUTO)
                                  LOOP
                                    IF (C_RECEFILI.IDPRODATIV = 'I') OR (C_RECEFILI.IDPRODATIVPR = 'N') THEN     /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                                       IF V_NRLOGINTCARD IS NULL THEN
                                          NOVO_CODIGO('LOGINTCARD'||C_CARDAPIOS.CDFILIAL, V_NRLOGINTCARD, 1);
                                          V_NRLOGINTCARD := SUBSTR(V_NRLOGINTCARD,11,10);
                                       END IF;
                                       V_PRODINATIVO := '1';
                                       GRAVA_LOGINTCARD(V_NRLOGINTCARD, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDSERVFILI, C_CARDAPIOS.DTCARDAPIO, C_RECEFILI.CDARVPROD, ' ', P_CDFAPRATDEST,  '0');
                                    END IF;
                                  END LOOP;

                               ELSE
                                 IF (V_TIPORECE ='P') THEN   /*RECEITA PADRO COM PRODUTO INATIVO*/

                                       FOR C_RECEPADR IN (
                                         SELECT P.CDARVPROD, P.IDPRODATIVPR, NVL(PF.IDPRODATIV, 'A') AS IDPRODATIV
                                         FROM   PRODUTO  P, PRODFILI PF, RECEPADR RP
                                         WHERE  P.CDNVPRODUTO        = P_CDNVPRODUTO   AND
                                                C_CARDAPIOS.CDFILIAL = PF.CDFILIAL(+)  AND
                                                P.CDPRODUTO          = PF.CDPRODUTO(+) AND
                                                RP.CDPRATO           = P_CDPRATDEST    AND
                                                RP.CDFILAUXPRAT      = P_CDFAPRATDEST  AND
                                                RP.CDPRODUTO         = P.CDPRODUTO)
                                       LOOP
                                         IF (C_RECEPADR.IDPRODATIV = 'I') OR (C_RECEPADR.IDPRODATIVPR = 'N') THEN /*O CAMPO CDPRATLOG (TABELA:LOGINTCARD) GUARDAR OS PRODUTO INATIVOS*/
                                            IF V_NRLOGINTCARD IS NULL THEN
                                               NOVO_CODIGO('LOGINTCARD'||C_CARDAPIOS.CDFILIAL, V_NRLOGINTCARD, 1);
                                               V_NRLOGINTCARD := SUBSTR(V_NRLOGINTCARD,11,10);
                                            END IF;
                                            V_PRODINATIVO := '1';
                                            GRAVA_LOGINTCARD(V_NRLOGINTCARD, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDSERVFILI, C_CARDAPIOS.DTCARDAPIO, C_RECEPADR.CDARVPROD, ' ', P_CDFAPRATDEST,  '0');
                                         END IF;
                                       END LOOP;

                                 END IF; /*RECEITA PADRO COM PRODUTO INATIVO*/
                               END IF;  /*RECEITA LOCAL COM PRODUTO INATIVO*/
                             END IF; /*RECEITA POR SERVIO COM PRODUTO INATIVO*/
                        END IF; /*SE EXISTIR O PRATO NO CARDAPIO DESTINO*/

                          IF (V_TIPORECE = 'P' AND V_IDUTRPADCA = 'N') THEN
                          /* 3- Prato sem receita revisada */
                             IF V_NRLOGINTCARD IS NULL THEN
                                NOVO_CODIGO('LOGINTCARD'||C_CARDAPIOS.CDFILIAL, V_NRLOGINTCARD, 1);
                                V_NRLOGINTCARD := SUBSTR(V_NRLOGINTCARD,11,10);
                             END IF;
                             GRAVA_LOGINTCARD(V_NRLOGINTCARD, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDFILIAL, C_CARDAPIOS.CDSERVFILI, C_CARDAPIOS.DTCARDAPIO, P_CDPRATDEST, ' ', P_CDFAPRATDEST,  '3');
                          ELSE
                            IF (V_PRODINATIVO = '0') THEN /*PRODUTO INATIVO NO PRATO*/
                                /* OK - Substitui prato */
                                 /*Cardpio LIVRE*/
                                 IF V_TIPOCARDAPIO = 'N' THEN
                                    UPDATE COMPCARD
                                    SET    CDPRATO = P_CDPRATDEST,
                                           CDFILAUXPRAT = P_CDFAPRATDEST
                                    WHERE  CDFILIAL     = C_CARDAPIOS.CDFILIAL AND
                                           NRCARDAPIO   = C_CARDAPIOS.NRCARDAPIO AND
                                           CDPRATO      = P_CDPRATORIG AND
                                           CDFILAUXPRAT = P_CDFAPRATORIG;
                                 END IF;
                                 /*Cardpio PADRONIZADO*/
                                 IF V_TIPOCARDAPIO = 'S' THEN
                                    SELECT
                                       MAX(OP.CDOPERADOR)
                                    INTO
                                       V_OPERDOGRUPO
                                    FROM
                                       AUTGRUPOP AP,
                                       OPERGRUPOP OP
                                    WHERE
                                       (AP.IDAUTGRUPOP = 'LRCD')        AND
                                       (AP.CDGRUPOPER  = OP.CDGRUPOPER) AND
                                       (OP.CDOPERADOR  = P_CDOPERADOR);
                                    /*Operador pertence ao grupo com permisso para revisar cardpio*/
                                    IF (V_OPERDOGRUPO IS NULL) THEN
                                       UPDATE COMPCARD
                                       SET    CDPRATO      = P_CDPRATDEST,
                                              CDFILAUXPRAT = P_CDFAPRATDEST,
                                              IDPRATOESPE  = 'S'
                                       WHERE  CDFILIAL     = C_CARDAPIOS.CDFILIAL AND
                                              NRCARDAPIO   = C_CARDAPIOS.NRCARDAPIO AND
                                              CDPRATO      = P_CDPRATORIG AND
                                              CDFILAUXPRAT = P_CDFAPRATORIG;

                                       IF C_CARDAPIOS.IDCARDIAESPE = 'N' THEN
                                          UPDATE CARDADIA
                                          SET    IDCARDIAESPE = 'S'
                                          WHERE  CDFILIAL   = C_CARDAPIOS.CDFILIAL AND
                                                 NRCARDAPIO = C_CARDAPIOS.NRCARDAPIO;
                                       END IF;
                                    ELSE
                                       UPDATE COMPCARD
                                       SET    CDPRATO      = P_CDPRATDEST,
                                              CDFILAUXPRAT = P_CDFAPRATDEST,
                                              IDPRATOESPE  = 'R'
                                       WHERE  CDFILIAL     = C_CARDAPIOS.CDFILIAL AND
                                              NRCARDAPIO   = C_CARDAPIOS.NRCARDAPIO AND
                                              CDPRATO      = P_CDPRATORIG AND
                                              CDFILAUXPRAT = P_CDFAPRATORIG;


                                       /*IF C_CARDAPIOS.IDCARDIAESPE = 'N' THEN
                                          UPDATE CARDADIA
                                          SET    IDCARDIAESPE = 'R'
                                          WHERE  CDFILIAL   = C_CARDAPIOS.CDFILIAL AND
                                                 NRCARDAPIO = C_CARDAPIOS.NRCARDAPIO;
                                       END IF; */


                                    END IF; /*Operador pertence ao grupo com permisso para revisar cardpio*/
                                 END IF; /*Cardpio PADRONIZADO*/

                                 IF V_TIPOCARDAPIO = 'D' THEN /*Cardpio DESCENTRALIZADO*/          
                                    FOR C_PRATOS IN (
                                       SELECT IDPRATOESPE, NRSEQPRATCAR, CDPRATOMAT, CDFILAUXPRATMAT, CDPRATO, CDFILAUXPRAT
                                         FROM COMPCARD
                                        WHERE CDFILIAL     = C_CARDAPIOS.CDFILIAL   AND
                                              NRCARDAPIO   = C_CARDAPIOS.NRCARDAPIO AND
                                              CDPRATO      = P_CDPRATORIG AND
                                              CDFILAUXPRAT = P_CDFAPRATORIG)
                                    LOOP 
                                       IF P_MODOPROC = 'M' THEN
                                          BEGIN 
                                             SELECT 'S'
                                               INTO V_IDLIBMATRIZ
                                               FROM CTRLAPROVCARD
                                              WHERE CDFILIAL = C_CARDAPIOS.CDFILIAL AND 
                                                    CDSERVFILI = C_CARDAPIOS.CDSERVFILI AND 
                                                    DTMESCARDAPROV = C_CARDAPIOS.DTMESCARD AND 
                                                    DTLIBECARDMATR IS NOT NULL;
                                          EXCEPTION
                                             WHEN NO_DATA_FOUND THEN
                                                V_IDLIBMATRIZ := 'N';
                                          END;                                           
                                          IF V_IDLIBMATRIZ = 'S' THEN
                                             IF ((C_PRATOS.CDPRATOMAT = P_CDPRATDEST) AND
                                                (C_PRATOS.CDFILAUXPRATMAT = P_CDFAPRATDEST)) THEN
                                                IF V_IDMANCORCARDALT = 'S' THEN 
                                                   V_IDPRATOESPE := 'R';
                                                   V_IDCARDIAESPE := 'S';                                                   
                                                   V_CDPRATOMAT := C_PRATOS.CDPRATOMAT;
                                                   V_CDFILAUXPRATMAT := C_PRATOS.CDFILAUXPRATMAT;
                                                ELSE
                                                   V_IDPRATOESPE := 'N';
                                                   V_IDCARDIAESPE := 'N';                                                
                                                   V_CDPRATOMAT := '';
                                                   V_CDFILAUXPRATMAT := '';
                                                END IF;
                                             ELSE                                 
                                                IF (C_PRATOS.CDPRATOMAT IS NULL) AND 
                                                   (C_PRATOS.CDFILAUXPRATMAT IS NULL) THEN 
                                                   IF C_PRATOS.IDPRATOESPE = 'N' THEN
                                                      V_IDPRATOESPE := 'R';
                                                      V_IDCARDIAESPE := 'S';
                                                      V_CDPRATOMAT := C_PRATOS.CDPRATO;
                                                      V_CDFILAUXPRATMAT := C_PRATOS.CDFILAUXPRAT;
                                                   ELSE
                                                      V_IDPRATOESPE := 'R';
                                                      V_IDCARDIAESPE := 'S';
                                                      V_CDPRATOMAT := C_PRATOS.CDPRATOMAT;
                                                      V_CDFILAUXPRATMAT := C_PRATOS.CDFILAUXPRATMAT;
                                                   END IF;   
                                                ELSE   
                                                   V_IDPRATOESPE := 'R';
                                                   V_IDCARDIAESPE := 'S';
                                                   V_CDPRATOMAT := C_PRATOS.CDPRATOMAT;
                                                   V_CDFILAUXPRATMAT := C_PRATOS.CDFILAUXPRATMAT;
                                                END IF;   
                                             END IF;     
                                          ELSE                                        
                                             V_IDPRATOESPE := 'N';
                                             V_IDCARDIAESPE := 'N';
                                             V_CDPRATOMAT := '';
                                             V_CDFILAUXPRATMAT := '';
                                          END IF;                                       
                                       ELSE                                                                                     
                                          /*FILIAL*/
                                          IF (C_PRATOS.CDPRATOMAT = P_CDPRATDEST) AND 
                                             (C_PRATOS.CDFILAUXPRATMAT = P_CDFAPRATDEST) THEN
                                             /*SE O PRATO INSERIDO FOR IGUAL AO LIBERADO PELA MATRIZ VERIFICA O PARAMETRO(SOLI.77247)*/
                                             IF V_IDMANCORCARDALT = 'S' THEN 
                                                V_IDPRATOESPE := 'S';
                                                V_IDCARDIAESPE := 'S';                                                   
                                                V_CDPRATOMAT := C_PRATOS.CDPRATOMAT;
                                                V_CDFILAUXPRATMAT := C_PRATOS.CDFILAUXPRATMAT;
                                             ELSE                                           
                                                V_IDPRATOESPE := 'N';
                                                V_IDCARDIAESPE := 'N';
                                                V_CDPRATOMAT := '';
                                                V_CDFILAUXPRATMAT := '';
                                             END IF;   
                                          ELSE                                                                                          
                                             /*O CAMPO DO PRATO LIBERADO PELA MATRIZ PODE ESTAR NULO. SE O ID DE PRATO ESPECFICO ESTIVER
                                             'N' SIGNIFICA QUE O PRATO AINDA NAO FOI ALTERADO, ENTAO PREENCHE O CAMPO DE PRATOMAT. SE O ID
                                             ESTIVER 'S' SIGNIFICA QUE A FILIAL J ALTEROU O PRATO E MESMO ASSIM O CAMPO DE MATRIZ EST NULO,
                                             OU SEJA, A MATRIZ LIBEROU O CARDPIO SEM PRATO*/
                                             IF (C_PRATOS.CDPRATOMAT IS NULL) AND 
                                                (C_PRATOS.CDFILAUXPRATMAT IS NULL) THEN 
                                                IF C_PRATOS.IDPRATOESPE = 'N' THEN
                                                   V_IDPRATOESPE := 'S';
                                                   V_IDCARDIAESPE := 'S';
                                                   V_CDPRATOMAT := C_PRATOS.CDPRATO;
                                                   V_CDFILAUXPRATMAT := C_PRATOS.CDFILAUXPRAT;                                                   
                                                ELSE
                                                   V_IDPRATOESPE := 'S';
                                                   V_IDCARDIAESPE := 'S';
                                                   V_CDPRATOMAT := C_PRATOS.CDPRATOMAT;
                                                   V_CDFILAUXPRATMAT := C_PRATOS.CDFILAUXPRATMAT;
                                                END IF;   
                                             ELSE   
                                                V_IDPRATOESPE := 'S';                          
                                                V_IDCARDIAESPE := 'S';
                                                V_CDPRATOMAT := C_PRATOS.CDPRATOMAT;
                                                V_CDFILAUXPRATMAT := C_PRATOS.CDFILAUXPRATMAT;
                                             END IF;
                                          END IF;   
                                       END IF;
                                       IF P_MODOPROC = 'F' THEN
                                          IF (C_PRATOS.CDPRATOMAT IS NULL) AND 
                                             (C_PRATOS.CDFILAUXPRATMAT IS NULL) THEN
                                             /*UTILIZA DOIS UPDATE PARA NO ENTRAR NA CONDIO DA TRIGGER 'GERA_HISTORICO_CARD'
                                             DA TABELA COMPCARD*/
                                             UPDATE COMPCARD                                                
                                                SET CDPRATO      = P_CDPRATDEST,
                                                    CDFILAUXPRAT = P_CDFAPRATDEST,
                                                    IDPRATOESPE  = '',
                                                    CDPRATOMAT   = V_CDPRATOMAT,
                                                    CDFILAUXPRATMAT = V_CDFILAUXPRATMAT
                                              WHERE CDFILIAL     = C_CARDAPIOS.CDFILIAL
                                                AND NRCARDAPIO   = C_CARDAPIOS.NRCARDAPIO
                                                AND CDPRATO      = P_CDPRATORIG
                                                AND CDFILAUXPRAT = P_CDFAPRATORIG
                                                AND NRSEQPRATCAR = C_PRATOS.NRSEQPRATCAR;
                                                
                                             UPDATE COMPCARD                                                
                                                SET IDPRATOESPE  = V_IDPRATOESPE
                                              WHERE CDFILIAL     = C_CARDAPIOS.CDFILIAL
                                                AND NRCARDAPIO   = C_CARDAPIOS.NRCARDAPIO
                                                AND CDPRATO      = P_CDPRATDEST
                                                AND CDFILAUXPRAT = P_CDFAPRATDEST
                                                AND NRSEQPRATCAR = C_PRATOS.NRSEQPRATCAR;                                                                                                
                                          ELSE
                                             UPDATE COMPCARD                                                
                                                SET CDPRATO      = P_CDPRATDEST,
                                                    CDFILAUXPRAT = P_CDFAPRATDEST,
                                                    IDPRATOESPE  = V_IDPRATOESPE,
                                                    CDPRATOMAT   = V_CDPRATOMAT,
                                                    CDFILAUXPRATMAT = V_CDFILAUXPRATMAT
                                              WHERE CDFILIAL     = C_CARDAPIOS.CDFILIAL
                                                AND NRCARDAPIO   = C_CARDAPIOS.NRCARDAPIO
                                                AND CDPRATO      = P_CDPRATORIG
                                                AND CDFILAUXPRAT = P_CDFAPRATORIG
                                                AND NRSEQPRATCAR = C_PRATOS.NRSEQPRATCAR;
                                          END IF;
                                       ELSE
                                          UPDATE COMPCARD                                                
                                             SET CDPRATO      = P_CDPRATDEST,
                                                 CDFILAUXPRAT = P_CDFAPRATDEST,
                                                 IDPRATOESPE  = V_IDPRATOESPE,
                                                 CDPRATOMAT   = V_CDPRATOMAT,
                                                 CDFILAUXPRATMAT = V_CDFILAUXPRATMAT
                                           WHERE CDFILIAL     = C_CARDAPIOS.CDFILIAL
                                             AND NRCARDAPIO   = C_CARDAPIOS.NRCARDAPIO
                                             AND CDPRATO      = P_CDPRATORIG
                                             AND CDFILAUXPRAT = P_CDFAPRATORIG
                                             AND NRSEQPRATCAR = C_PRATOS.NRSEQPRATCAR;
                                       END IF;                                                
                                       
                                       UPDATE CARDADIA
                                          SET IDCARDIAESPE = V_IDCARDIAESPE
                                        WHERE CDFILIAL   = C_CARDAPIOS.CDFILIAL 
                                          AND NRCARDAPIO = C_CARDAPIOS.NRCARDAPIO;                                                
                                    END LOOP;                   
                                 END IF;  /*DESCENTRALIZADO */
                            END IF; /*PRODUTO INATIVO NO PRATO*/
                          END IF; /* 3- Prato sem receita revisada */
                     END IF; /* 2- Prato sem receita */
                  END IF;
               END IF;
            END IF;
         END IF;
   END LOOP;
   COMMIT;   
   P_NRLOGINTCARD := NVL(V_NRLOGINTCARD, '');
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('TROCA_PRATO_CARD','5.65.000'); END;
/

